package com.codegeist.fisheye.domain;

/**
 * <pre>
 * struct RevisionKey {
 *  String path; // (REST: attribute)
 *  String rev; // (REST: attribute)
 * }
 * </pre>
 * @author Brock Janiczak
 *
 */
public class RevisionKey {
	private final String path;
	private final String rev;
	
	public RevisionKey(String path, String rev) {
		super();
		this.path = path;
		this.rev = rev;
	}

	public String getPath() {
		return path;
	}

	public String getRev() {
		return rev;
	}
	
	@Override
	public String toString() {
		return path + " : " + rev;
	}
}
