package com.codegeist.fisheye.domain.query;

public class AuthorRestriction implements Restriction {
	private final String author;

	public AuthorRestriction(String author) {
		if (author == null) {
			throw new IllegalArgumentException("Author must not be null or empty");
		}
		this.author = author;
	}
	
	public StringBuilder appendEyeQlFragment(StringBuilder buffer) {
		buffer.append(" author = ");
		buffer.append(author);
		
		return buffer;
	}
}
