package com.codegeist.fisheye.domain.query;

public class TagRangeRestriction implements Restriction {

	private final String fromTag;
	private final boolean fromInclusive;
	private final String toTag;
	private final boolean toInclusive;

	public TagRangeRestriction(String fromTag, String toTag) {
		this(fromTag, true, toTag, true);
	}
	
	public TagRangeRestriction(String fromTag, boolean fromInclusive, String toTag, boolean toInclusive) {
		this.fromTag = fromTag;
		this.fromInclusive = fromInclusive;
		this.toTag = toTag;
		this.toInclusive = toInclusive;
	}
	
	public StringBuilder appendEyeQlFragment(StringBuilder buffer) {
		buffer.append(" between tags ");
		if (fromInclusive) {
			buffer.append("[");
		} else {
			buffer.append("(");
		}
		
		buffer.append(fromTag);
		buffer.append(", ");
		buffer.append(toTag);
		
		if (toInclusive) {
			buffer.append("]");
		} else {
			buffer.append(")");
		}
		return buffer;
	}
}
