package com.codegeist.fisheye.internal.service;

import java.util.ArrayList;
import java.util.List;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class ArrayHandler<T> extends DefaultHandler implements Handler<List<T>>{
	private List<T> result = new ArrayList<T>();
	private final Handler<T> delegate;
	private final String elementName;
	
	public ArrayHandler(String elementName, Handler<T> delegate) {
		this.elementName = elementName;
		this.delegate = delegate;
	}
	
	@Override
	public void startDocument() throws SAXException {
	}

	@Override
	public void startElement(String uri, String localName, String name, Attributes attributes) throws SAXException {
		if (elementName.equals(localName)) {
			delegate.startDocument();
			delegate.startElement(uri, localName, name, attributes);
		} else {
			delegate.startElement(uri, localName, name, attributes);
		}
	}
	
	@Override
	public void endElement(String uri, String localName, String name) throws SAXException {
		if (elementName.equals(localName)) {
			delegate.endDocument();
			result.add(delegate.getResult());
		} else {
			delegate.endElement(uri, localName, name);
		}
	}
	
	
	@Override
	public void endDocument() throws SAXException {
	}
	
	@Override
	public void characters(char[] ch, int start, int length) throws SAXException {
		delegate.characters(ch, start, length);
	}
	
	public List<T> getResult() {
		return result;
	}
}
